% Example-22: Scheduling using Specific Resources
%   This example is to explain how specific resources 
%   (named resources) are handled in GPenSIM 
% Reggie.davidrajuh@uis.no  (c) 20 Nov 2017

function [fire, trans] = COMMON_PRE(trans)
global global_info

switch trans.name
    case {'T1', 'T2'}       
        granted = requestSR({'project manager',1,'chief developer',1});

    case 'T3'
        granted = requestSR({'project manager',1, ...
            'chief developer',1, 'senior developers',1});

    case 'T4', granted = requestGR(6); % T4 seeks any 6 resources
    case 'T5', granted = requestGR(1); % T5 seeks any 1 resource
    case 'T6', granted = requestGR(3); % T6 seeks any 3 resources

    case {'T7', 'T8'}
        % T7 and T8 seek 'chief developer' and any 1 resources instances
        granted1 = requestSR({'chief developer',1}); 
        granted2 = requestGR(1);
        granted = and(granted1, granted2);        
        
    otherwise % 'T9'
    global_info.STOP_SIMULATION = 1; % stop simulations 
    granted = 1;
end
fire = granted;
